import java.awt.*;
class Main extends Frame {
    Main() {
        super("deliverEvent Example");

        setLayout(new FlowLayout());
        add(new MainButton("SmallFont"));
        add(new MainButton("LargeFont"));
        resize(200, 200);
        show();
    }

    public boolean action(Event evt, Object arg) {
        Font f = null;

        if ("SmallFont".equals(arg)) {
            f = new Font("Helvetica", Font.PLAIN, 12);
        } else if ("LargeFont".equals(arg)) {
            f = new Font("Helvetica", Font.PLAIN, 30);
        }
        if (f != null) {
            for (int i=0; i<countComponents(); i++) {
                Component c = getComponent(i);
                deliverEvent(new Event(this, 0, Event.ACTION_EVENT,
                    c.bounds().x, c.bounds().y, 0, 0, f));
            }
            layout();
            /* instead of layout(), the following would also work:
              invalidate();
              validate();
            */
            return true;
        }
        return false;
    }

    public static void main(String[] args) {
        new Main();
    }
}

class MainButton extends Button {
    MainButton(String label) {
        super(label);
    }

    public boolean action(Event evt, Object arg) {
        if (arg instanceof Font) {
            setFont((Font)arg);
            return true;
        }
        return false;
    }
}
