import java.awt.*;
class Main extends Frame {
    Image tinyIm;
    Graphics tinyImG;

    Main() {
        super("drawImage Example");
        resize(200, 100);
        show();
    }

    public void paint(Graphics g) {
        Insets insets = this.insets();
        int x = 0, y = 0;
        int w = size().width-insets.left-insets.right;
        int h = size().height-insets.top-insets.bottom;

        g.setColor(Color.black);
        paintFigure(g, w, h);
        if (tinyIm == null || tinyIm.getWidth(null) != w 
                || tinyIm.getHeight(null) != h) {
            if (tinyImG != null) tinyImG.dispose();
            tinyIm = createImage(w, h);
            tinyImG = tinyIm.getGraphics();
            paintFigure(tinyImG, w, h);
        }
        g.drawRect(0, 0, w/4+1, h/4+1);
        g.drawImage(tinyIm, 1, 1, w/4, h/4, null);
    }

    public void paintFigure(Graphics g, int w, int h) {
        Color c = g.getColor();
        Polygon polygon = new Polygon();
        polygon.addPoint(w/6, 0);
        polygon.addPoint(0, h);
        polygon.addPoint(w/3, h);

        g.setColor(Color.red);
        g.fillPolygon(polygon);
        g.setColor(Color.green);
        g.fillOval(w/3, 0, w/3, h);
        g.setColor(Color.blue);
        g.fillRect(w*2/3, 0, w/3, h);
        g.setColor(c);
    }

    static public void main(String[] args) {
        new Main();
    }
}
