import java.awt.*;
import java.util.*;
class Main extends Frame {
    Main() {
        super("drawRect Example");
        add("Center", new MainCanvas());
        resize(200, 200);
        show();
    }
    static public void main(String[] args) {
        new Main();
    }
}

class MainCanvas extends Canvas {
    Vector rects = new Vector();
    int startX, startY;
    Rectangle oldRect, newRect;

    public void paint(Graphics g) {
        update(g);
    }

    public void update(Graphics g) {
        // First erase old rect.
        if (oldRect != null) {
            g.setXORMode(Color.white);
            g.drawRect(oldRect.x, oldRect.y, oldRect.width, oldRect.height);
            g.setPaintMode();
        }
        // Now paint rectangles.
        for (int i=0; i<rects.size(); i++) {
            Rectangle r = (Rectangle)rects.elementAt(i);
            g.drawRect(r.x, r.y, r.width, r.height);
        }
        if (newRect != null) {
            g.setXORMode(Color.white);
            g.drawRect(newRect.x, newRect.y, newRect.width, newRect.height);
            g.setPaintMode();
        }
        oldRect = newRect;
        newRect = null;
    }

    public boolean mouseDown(Event evt, int x, int y) {
        startX = x;
        startY = y;
        newRect = new Rectangle(x, y, 1, 1);
        repaint();
        return true;
    }

    public boolean mouseDrag(Event evt, int x, int y) {
        newRect = new Rectangle(startX, startY, x-startX, y-startY);
        repaint();
        return true;
    }

    public boolean mouseUp(Event evt, int x, int y) {
        rects.addElement(new Rectangle(startX, startY, x-startX, y-startY));
        newRect = null;
        repaint();
        return true;
    }
}
