import java.awt.*;
class Main extends Frame {
    String[] figureNames = {"circle", "oval", "square", "rectangle"};
    String[] colorNames = {"red", "green", "blue", "yellow"};
    Color[] colorValues = {Color.red, Color.green, 
                           Color.blue, Color.yellow};
    Choice chFigure = new Choice();
    Choice chColor = new Choice();
    int curX, curY;

    Main() {
        super("fillRect Example");
        Panel p = new Panel();

        for (int i=0; i<figureNames.length; i++) {
            chFigure.addItem(figureNames[i]);
        }
        for (int i=0; i<colorNames.length; i++) {
            chColor.addItem(colorNames[i]);
        }
        p.setLayout(new GridLayout(1, 0));
        p.add(chColor);
        p.add(chFigure);
        add("North", p);
        resize(300, 300);
        show();
    }

    public void update(Graphics g) {
        g.setColor(colorValues[chColor.getSelectedIndex()]);
        switch (chFigure.getSelectedIndex()) {
        case 0: // circle
            g.fillOval(curX, curY, 30, 30);
            break;
        case 1: // oval
            g.fillOval(curX, curY, 30, 50);
            break;
        case 2: // square
            g.fillRect(curX, curY, 30, 30);
            break;
        case 3: // rectangle
            g.fillRect(curX, curY, 30, 50);
            break;
        }
    }

    public boolean mouseDown(Event evt, int x, int y) {
        curX = x;
        curY = y;
        repaint();
        return true;
    }

    static public void main(String[] args) {
        new Main();
    }
}
