// This example creates a 3x3 gridbag with eight buttons.
// Pressing a button adjacent to the empty cell moves that
// button into the empty cell.

import java.awt.*;
public class Main extends Frame {
    GridBagLayout gbl = new GridBagLayout();

    Main() {
	super("GridBagConstraints Example");
        setLayout(gbl);
        for (int i=1; i<5; i++) {
            for (int j=i; j<4; j++) {
		makeButton(i);
            }
            if (i%2 == 0) {
		makeButton(GridBagConstraints.RELATIVE);
            }
            makeButton(GridBagConstraints.REMAINDER);
        }
        resize(300, 300);
	show();
    }

    String getLabel(int w) {
        if (w == GridBagConstraints.RELATIVE) return "relative";
        else if (w == GridBagConstraints.REMAINDER) return "remainder";
        else return "" + w;
    } 

    // Returns the new button.
    Component makeButton(int w) {
        GridBagConstraints c = new GridBagConstraints();
        Button b = new Button(getLabel(w));

        c.gridwidth = w;
        c.gridheight = 1;
        c.fill = GridBagConstraints.BOTH;
        c.weightx = 1;
        c.weighty = 1;
        gbl.setConstraints(b, c);
        add(b);
        return b;
    }

    public boolean action(Event evt, Object arg) {
        Button b = (Button)evt.target;
        GridBagConstraints gbc = gbl.getConstraints(b);

        if (gbc.gridwidth == GridBagConstraints.RELATIVE) {
            gbc.gridwidth = GridBagConstraints.REMAINDER;
        } else if (gbc.gridwidth == GridBagConstraints.REMAINDER) {
            gbc.gridwidth = 1;
        } else if (gbc.gridwidth < 4) {
            gbc.gridwidth++;
        } else {
            gbc.gridwidth = GridBagConstraints.RELATIVE;
        }
        gbl.setConstraints(b, gbc);
        b.setLabel(getLabel(gbc.gridwidth));
        invalidate();
        validate();
        return true;
    }

    static public void main(String[] args) {
        new Main();
    }
}
