import java.awt.*;
public class Main extends Frame {
    GridBagLayout gbl = new GridBagLayout();
    Main() {
        super("getLayoutOrigin Example");
        GridBagConstraints c = new GridBagConstraints();
        Checkbox cb;

        c.fill = GridBagConstraints.BOTH;
        setLayout(gbl);
        add(cb = new Checkbox("weightx > 0.0"));
        gbl.setConstraints(cb, c);
        add(cb = new Checkbox("weighty > 0.0"));
        gbl.setConstraints(cb, c);
        resize(300, 100);
        show();
    }

    public void paint(Graphics g) {
        Insets insets = this.insets();
        int dotSize = 20;
        Point p = gbl.getLayoutOrigin();

        g.setColor(Color.black);
        g.fillRect(0, 0, size().width, size().height);
        g.setColor(Color.red);
        g.fillOval(p.x-dotSize/2-insets.left, p.y-dotSize/2-insets.top, 
            dotSize, dotSize);
    }

    public boolean action(Event evt, Object arg) {
        if (evt.target instanceof Checkbox) {
            Checkbox cb = (Checkbox)evt.target;
            GridBagConstraints c = gbl.getConstraints(cb);

            if ("weightx > 0.0".equals(cb.getLabel())) {
                c.weightx = cb.getState() ? 1 : 0;
            } else {
                c.weighty = cb.getState() ? 1 : 0;
            }
            gbl.setConstraints(cb, c);
            invalidate();
            validate();
            repaint();
            return true;
        }
        return false;
    }
    static public void main(String[] args) {
        new Main();
    }
}
