import java.awt.*;
class Main extends Frame {
    int dotSize = 10;
    Point[] pts = new Point[100];

    Main() {
        super("Point Example");
        for (int i=0; i<pts.length; i++) {
            pts[i] = new Point(0, 0);
        }
        setForeground(Color.red);
        resize(100, 100);
        show();
    }

    // Returns a random integer in the range [0..r-1].
    int random(int r) {
        r = Math.max(r, 0);
        return (int)(Math.floor(Math.random()*r));
    }

    public void paint(Graphics g) {
        Insets insets = insets();
        int w = size().width-insets.left-insets.right;
        int h = size().height-insets.top-insets.bottom;

        for (int i=0; i<pts.length; i++) {
            pts[i].move(random(w-dotSize), random(h-dotSize));
        }
    }

    public void update(Graphics g) {
        for (int i=0; i<pts.length; i++) {
            if (pts[i].x < 0) {
                g.fillOval(-pts[i].x, -pts[i].y, dotSize, dotSize);
            }
        }
    }

    public boolean mouseMove(Event evt, int x, int y) {
        Point p = new Point(x-dotSize/2, y-dotSize/2);
        
        for (int i=0; i<pts.length; i++) {
            if (p.equals(pts[i])) {
                pts[i].x = -pts[i].x;
                pts[i].y = -pts[i].y;
                repaint();
                break;
            }
        }
        return true;
    }

    static public void main(String[] args) {
        new Main();
    }
}
