import java.net.*;
import java.io.*;


class examples {
// START tostr
public static void socketDetails(Socket s) {
    System.out.println("Socket is " + s.toString());
    System.out.println("Socket is to " + s.getInetAddress() +
		       "(" + s.getPort() + ")" +
		       " from local port" + s.getLocalPort());
}
// END tostr
// START output
// write string to socket
public static void writeToSocket(Socket s, String msg) {
    try {
	OutputStream out = s.getOutputStream();
	if (out != null) {
	    byte[] ob = new byte[msg.length()];
	    msg.getBytes(0, ob.length, ob, 0);
	    out.write(ob, 0, ob.length);
	    out.flush();
	    // close() will happen when socket gets closed
	}
    } catch (IOException e) {
	System.err.println("Had problems with writing to socket: " + e);
    }
}
// END output

    public static void main(String[] args) {
/*
// START factory
try {
    Socket.setSocketImplFactory(new DebugSocketImplFactory());
} catch (IOException e) {
    System.out.println("Cannot set Socket factory: " + e);
}
// END factory
*/
// START socket
try {
    //  9 == 'discard' port, false == not a stream socket
    Socket sock = new Socket("localhost", 9, false);
    
    socketDetails(sock);
    writeToSocket(sock, "this is a test");
    sock.close();
} catch (IOException e) {
    e.printStackTrace();
}
// END socket
}
}
